Changelog
=========

1.4.0
---
- (added) optional GUI from QJackTrip
- (added) authentication in hub server mode
- (added) different number of sending and receiving channels
- (added) append thread IDs to jack client names
- (added) new patcher mechanism that doesn't delete existing connections
- (added) MkDocs based documentation
- (added) weak jack linking
- (added) manpage
- (added) MSVC build
- (added) RtAudio Meson subproject
- (added) formatting with clang-format
- (added) static analysis with clang-tidy
- (added) cross compilation for Windows
- (added) flatpaks
- (added) appstream
- (added) automated builds and deployment for Linux, macOS and Windows
- (added) macOS and Windows Installers
- (fixed) regression in remote client name handling
- (fixed) long jack client names (> 27 characters) in 1.9.11
- (fixed) Hardcode Derived Class Names of ProcessPlugins to prevent undefined behavior
- (update) QJackTrip and JackTrip are now identical
- (update) Change helpscreen wording for --broadcast argument
- (update) jitter buffer alternatives
- (update) RtAudio revive
- (update) RtAudio device selection
- (update) build script moved to root directory

1.3.0
---
- (added) async networking in hub listener
- (added) limiter, compressor, reverb
- (added) examine audio delay
- (added) jitter buffer alternatives
- (added) broadcast output ports
- (added) PREFIX variable for installation path
- (added) disconnect on timeout
- (added) SIGTERM
- (added) simulate packet loss, jitter
- (added) hubpatch 5, no auto patching
- (added) jack client name length check
- (added) scripts/hubMode/test_hub_mode_server_and_client.sh
- (added) Meson build
- (fixed) misc. typos, indentation
- (fixed) short form IO stat options
- (fixed) nullptr jack server name when creating jack client
- (fixed) stop ring buffer blocking when jack has been stopped
- (fixed) JMess handling of non-western characters
- (fixed) closing curly brace on mJackTrip client creation
- (fixed) Warnings
- (fixed) remove rtaudio device and mpeeraddress msgs.
- (fixed) signal and slot connections
- (fixed) incorrect dependency from jacktrip_main
- (update) RT thread priority for network I/O
- (update) clipping to saturation
- (update) build instructions

1.2.2
---
- (added) bindPort range to reject oddball connections
- (fixed) jack client name strings

1.2.1
---
- (added) src/build script builds in ../builddir
- (fixed) refactor "Master" to be "Hub"
- (fixed) 1.2.1 correctly versioned and tagged

1.2
---
- (added) jack patching modes (-p) for Hub Mode server (-S)
- (fixed) Compilation under ubuntu
- (removed) setRealtimeProcessPriority()
- (removed) Rtaudio mode (but still has dependencies)
- (fixed) IPv4-mapped IPv6 addressing bug
...
- (fixed) Fixed compilation for  MacOSX10.11.sdk.
- (update) Updated to RtAudio 4.1.1, and using shared lib in linux.

1.1
---
- (added) Support for RtAudio. Jacktrip can now be used without Jack
- (added) DNS Look-up support, now one machine can have a private IP (but still needs to have UDP ports open)
- (added) New port to Windows XP and Windows Vista (experimental and not tested for a long time, only when using jacktrip as a library)
- (added) Multiclient Server (experimental and not exposed in the executable)

1.0.5
---
- (added) Compatibility with JamLink boxes (restricted at the moment to 48KHz, 64 buffer size and 1 channel)
- (added) New port structure that allows the communication between a public server and a local client
- (added) Option for packets without header
- (added) Option to change default client name
- (fixed) General optimizations and code cleanup
- (added) Improved, now cross-platform build script

1.0.4
---
- (fixed) Buss error caused when no physical inputs or outputs ports are available

1.0.3
---
- (added) Redundancy Algorithm for UDP Packets to avoid glitches with packet losses
- (fixed) Now compiles on 64bits machines
- (fixed) Improved exceptions handling
- (added) Basic Karplus-Strong model added as Plug-in
- (added) Some functionality reimplemented using signals and slots for more flexibility
- (added) Multiple-Client-Server in alpha testing, expect it working in the next release

1.0.2 Alpha
---
- (added) Port offset mode, to use a different UDP port than the default one.
- (fixed) Improved thread behavior

1.0.1 Alpha
---
- (added) jamlink mode to connect with jamlink boxes
- (fixed) thread priority in both Linux and Mac OS X (still need some work on the Mac OS X version)
- (fixed) Bug that was causing plug-ins not to behave correctly
- (added) Loopback mode
- (added) Underrun Modes: Wavetable (default) and set to zeros
- (added) Check for peer audio settings, program exists if they don't match
- (added) Automatically connect ports to available physical audio interface.

1.0 Alpha  - initial release
---
